class LikeHook  < Redmine::Hook::ViewListener

    def view_projects_show_left(context = {})
        settings = Setting.plugin_like_plugin
        RAILS_DEFAULT_LOGGER.info context[:request].inspect
        if settings[:location] == 'mainarea'
            attributes = like_attributes(context[:request].url.gsub(/\?.*/, ''), settings)
            return like_iframe(attributes)
        end
        return ''
    end

    def view_wiki_show_left(context = {})
        settings = Setting.plugin_like_plugin
        if settings[:location] == 'mainarea'
            attributes = like_attributes(context[:request].url.gsub(/\?.*/, ''), settings)
            return like_iframe(attributes)
        end
        return ''
    end

    def view_wiki_index_left(context = {})
        settings = Setting.plugin_like_plugin
        url = url_for(:only_path => false, :host => context[:request].host,
                      :controller => 'news', :action => 'show', :id => context[:news])
        attributes = like_attributes(url, settings)
        return like_iframe(attributes)
    end

    def view_news_show_left(context = {})
        settings = Setting.plugin_like_plugin
        attributes = like_attributes(context[:request].url.gsub(/\?.*/, ''), settings)
        return like_iframe(attributes)
    end

    def view_projects_show_sidebar_bottom(context = {})
        settings = Setting.plugin_like_plugin
        if settings[:location] == 'sidebar'
            attributes = like_attributes(context[:request].url.gsub(/\?.*/, ''), settings)
            return content_tag(:p, like_iframe(attributes))
        end
        return ''
    end

    def view_wiki_show_sidebar_top(context = {})
        settings = Setting.plugin_like_plugin
        if settings[:location] == 'sidebar'
            attributes = like_attributes(context[:request].url.gsub(/\?.*/, ''), settings)
            return content_tag(:p, like_iframe(attributes))
        end
        return ''
    end

private

    def like_attributes(url, settings)
        return {
            :href        => CGI.escape(url),
            :layout      => settings[:location] == 'sidebar' ? 'button_count' : 'standard',
            :show_faces  => settings[:show_faces] ? 'true' : 'false',
            :width       => settings[:width].to_i > 0 ? settings[:width].to_i : settings[:location] == 'sidebar' ? 150 : 450,
            :action      => settings[:action],
            :colorscheme => settings[:colorscheme],
            :height      => settings[:location] == 'sidebar' ? 21 : settings[:show_faces] ? 80 : 35
        }
    end

    def like_iframe(attributes)
        return content_tag(:iframe, nil,
            :src         => "http://www.facebook.com/plugins/like.php?#{attributes.to_query}",
            :scrolling   => 'no',
            :frameborder => 0,
            :style       => "border: none; overflow: hidden; width: #{attributes[:width]}px; height: #{attributes[:height]}px;",
            :allowTransparency => 'true'
        )
    end

end
